import java.awt.*;
import java.applet.*;

public class MovingCircles extends Applet implements Runnable
{
	double angle;
	static final Color colors[] = {
				new Color(255, 20, 255), 
				new Color(255, 200, 230),
				new Color(0, 200, 240),
				new Color(0, 0, 255),
				new Color(255, 200, 50),
				new Color(50, 255, 220)
				};
	
	Image buf;
	static double sin(double a)
	{
		return Math.sin(a);
	}
	static double cos(double a)
	{
		return Math.cos(a);
	}
	public void start()
	{
		setBackground(new Color(0, 32, 64));

		buf = createImage(getSize().width, getSize().height);
		angle = 0;
		new Thread(this).start();
	}

	public void run()
	{
		try
		{
			while (true)
			{
				Graphics g = getGraphics();
				update(buf.getGraphics());
				g.drawImage(buf, 0, 0, null, null);
				Thread.sleep(100);
				angle += Math.PI / 64;
			}
		} 
		catch (Exception e)
		{
		}
	}
		

	public void update(Graphics g)
	{
		paint(g);
	}
	public void paint(Graphics g)
	{
		double r = (double)
			  (getSize().height < getSize().width ? 
			   getSize().height : getSize().width);
		DrawCircle(g, (double)getSize().width / 2.0, 
			      (double)getSize().height / 2.0, 
			      r / 2, r / 2, 0, angle); 
	}

	public void DrawCircle(Graphics g, double x, double y, double w, double h, int c, double a)
	{
		if (c >= colors.length)
			c -= colors.length;

		g.setColor(colors[c]);
		g.fillOval((int)(x-w), (int)(y-h), (int)w*2, (int)h*2);
		if (w < 0.5 || h < .5)
			return;
		DrawCircle(g, x-w/2 * cos(a), y - h/2 * sin(a), w / 2, h/2, c + 2, a + angle);
		DrawCircle(g, x+w/2 * cos(a), y + h/2 * sin(a), w / 2, h/2, c + 1, a + angle);
	}
}
